# -*- coding: utf-8 -*-
import numpy as np
import matplotlib.pyplot as plt
from matplotlib import rcParams
import seaborn as sns
from Myproblem import MyProblem
from tools import *
from HMOA_noLS import HMOA_noLS
from MOEAD import MOEAD
from MOMAD import MOMAD
from HMOA import HMOA


"""================================Experiments============================"""
# benchmark path
file_path = 'E:/LQZ/comparison_study/'
# save path
outpath = 'E:/LQZ/experimental_results/'

problemNames = get_problemName(file_path)

for problemName in problemNames:
        # problemName = 'n20w80_002.json'

        runtime = []
        all_pfs = []
        all_finalpfs = []
        all_finalsol = []
        repeat = 0

        problem = MyProblem(problemName, file_path) # define problem
        NIND = 100             # populzation size
        max_iter = 200 # maximum iterations
        
        while repeat < 20:
                
                print ('{}th run, benchmark:{}'.format(repeat, problemName))

                # myAlgorithm = HMOA_noLS(problem, NIND, max_iter)
                # myAlgorithm = MOEAD(problem, NIND, max_iter)
                myAlgorithm = HMOA(problem, NIND, max_iter)
                # myAlgorithm = MOMAD(problem, NIND, max_iter)
                myAlgorithm.run()

                # store data
                time = myAlgorithm.metric.runTime
                pfs = myAlgorithm.metric.paretoFs
                finalpfs = myAlgorithm.metric.finalPFs
                finalsol = myAlgorithm.metric.finalsolution
                runtime.append(time)
                all_pfs.append(pfs)
                all_finalpfs.append(finalpfs)
                all_finalsol.append(finalsol)

                myAlgorithm.draw(problemName, outpath, repeat)
                # myAlgorithm.plot_map()
                myAlgorithm.draw_HV()
                # myAlgorithm.draw_cost()

                repeat += 1
        print(problemName, 'finished')
        
        # # store run time
        # AlgorithmName = myAlgorithm.metric.algorithm
        # averagetime = sum(runtime)/len(runtime)
        # store_time(outpath, problemName, AlgorithmName, averagetime)

        # #store data
        # all_pfs = np.array(all_pfs)
        # all_finalpfs = np.array(all_finalpfs)
        # all_finalsol = np.array(all_finalsol)
        
        # np.save(outpath+problemName+'_'+AlgorithmName+'_pfs', all_pfs)
        # np.save(outpath+problemName+'_'+AlgorithmName+'_finalpfs', all_finalpfs)
        # np.save(outpath+problemName+'_'+AlgorithmName+'_finalsol', all_finalsol)


print('all done')